#ifndef MAKE_ID
#define MAKE_ID(a,b,c,d) ((ULONG) (a)<<24 | (ULONG) (b)<<16 | (ULONG) (c)<<8 | (ULONG) (d))
#endif

/* Libraries */
#include <libraries/mui.h>
#include <libraries/gadtools.h> /* for Barlabel in MenuItem */
#include <libraries/dos.h>
#include <exec/memory.h>
#include <utility/tagitem.h>
#include <intuition/intuition.h>
#include <intuition/classusr.h>
//#include <mui/NDirlist_mcc.h>
#include <mui/NlistView_mcc.h>

/* Prototypes */
#include <proto/muimaster.h>
#include <proto/exec.h>
#include <clib/alib_protos.h>
#include <proto/intuition.h>
#include <proto/utility.h>
#include <proto/dos.h>

/* program */
#include "ListersGUI.h"
#include "DirTools.h"
#include "MyList.h"


struct MUI_CustomClass *MyList=NULL;

static char *GetMBString(APTR ref)
{
    char *aux;

    aux = GetListersString(ref);
    if (aux[1] == '\0') return(&aux[2]);
    else                return(aux);
}

ULONG MyList_New(struct IClass *cl , Object *obj, Msg msg)
{
    return 0;
}


ULONG MyList_Set(struct IClass *cl , Object *obj, Msg msg)
{                   
    struct MyList_Data *data = INST_DATA(cl, obj);
    struct TagItem *tags,*tag;

    for(tags=((struct opSet *)msg)->ops_AttrList; tag=NextTagItem(&tags); )
    {
        switch(tag->ti_Tag)
        {
            case MUIA_MyList_Path:
                    strcpy(data->path,(char *)tag->ti_Data);
                    data->path[strlen((char *)tag->ti_Data)]=0;
                    Refresh_DirList(obj);
                    break;
        }
    }

    return(DoSuperMethodA(cl, obj, msg));
}


ULONG MyList_Get(struct IClass *cl, Object *obj, Msg msg)
{
    struct MyList_Data *data = INST_DATA(cl, obj);
    ULONG *store = ((struct opGet *)msg)->opg_Storage;

    switch( ((struct opGet *)msg)->opg_AttrID )
    {   
        case MUIA_MyList_Path: memcpy((char *)(*store),data->path,strlen(data->path));return(TRUE);
    }

    return(DoSuperMethodA(cl, obj, msg));
}

ULONG MyList_DragQuery(struct IClass *cl,Object *obj,struct MUIP_DragDrop *msg)
{
    if (msg->obj==obj)
    {   //return(MUIV_DragQuery_Accept);
        return(DoSuperMethodA(cl,obj,(Msg)msg));
    }
    else
    {
        if (msg->obj==(Object *)muiUserData(obj))
            return(MUIV_DragQuery_Accept);

        else
            return(MUIV_DragQuery_Refuse);
    }

}

ULONG MyList_DragDrop(struct IClass *cl,Object *obj,struct MUIP_DragDrop *msg)
{
    struct FileInfoBlock *dest;
    LONG dropmark;
    char *dest_path;

    //kprintf("\n\nDans Drag drop");
    printf("[DRAG_DROP] Drag&drop started...\n");
    if( !(dest_path=malloc(380)) ||
        !(dest=malloc(sizeof(struct FileInfoBlock)))) return 1;

    /* get destination */
    get(obj,MUIA_List_DropMark,&dropmark);
    DoMethod(msg->obj,MUIM_List_GetEntry,dropmark-1,&dest);

    /* copy entry in dest and remove entry from list */
    if (dest->fib_DirEntryType>0)
    {   int len=0;
        get(msg->obj,MUIA_MyList_Path,&dest_path);
        len = strlen(dest_path);
        if(dest_path[len-1] != ':')
        {   dest_path[len] = '/';
            dest_path[len+1] = 0;
        }
        strcat(dest_path,dest->fib_FileName);
        strcat(dest_path,"/");
        printf("[DRAG_DROP] Got destination: \"%s\"\n",dest_path);
        CopySelected(msg->obj,dest_path,TRUE);
    }

    free(dest_path);
    free(dest);
}

ULONG MyList_ExternDrop(Object *obj, struct MUIP_ExternDrop *msg)
{
    char *dest_path=NULL;
    Object *WinObj=NULL;
    int len=0;
    if(!(dest_path=malloc(380))) return;
    
    /* get dest path */
    get(obj,MUIA_MyList_Path,&dest_path);
    len = strlen(dest_path);
    if(dest_path[len-1] != ':')
    {   dest_path[len] = '/';
        dest_path[len+1] = 0;
    }

    CopySelected(((struct ObjApp *) (msg->App))->LV_lister,dest_path,FALSE);
    get(obj,MUIA_WindowObject,&WinObj);
    set(WinObj,MUIA_Window_Activate,TRUE);
    Refresh_DirList(obj);

    free(dest_path);
}

MUI_DISPATCH(MyList_Dispatcher)
{
    switch (msg->MethodID)
    {
        //case OM_NEW        : return(MyList_New  (cl,obj,(APTR)msg));
        case OM_SET        : return(MyList_Set  (cl,obj,(APTR)msg));
        case OM_GET        : return(MyList_Get  (cl,obj,(APTR)msg));
        
        case MUIM_DragQuery: return(MyList_DragQuery(cl,obj,(APTR)msg));
        case MUIM_DragDrop : return(MyList_DragDrop (cl,obj,(APTR)msg));
        case MUIM_ExternDrop:return(MyList_ExternDrop(obj,(APTR)msg));
    }
    return(DoSuperMethodA(cl,obj,msg));
}


void ExitClasses(void)
{
    if (MyList)
	{
        MUI_DeleteCustomClass(MyList);
		MyList = NULL;
	}
}   

BOOL InitClasses(void)
{
    MyList = MUI_CreateCustomClass(NULL,MUIC_NList ,NULL,sizeof(struct MyList_Data),&MyList_Dispatcher);

	if (MyList) return(TRUE);
	else        return FALSE;
}


struct ObjApp * CreateApp(APTR Start_Lister)
{
    struct ObjApp * ObjectApp;

    APTR    MNlabel0Project, MNlabel0MUIPrefs, MNlabel0AboutMUi, MNlabel0About;
    APTR    GROUP_ROOT_0, GR_up, GR_buttons, IM_device, IM_back, IM_select, IM_selectPattern;
    APTR    IM_createdir, IM_copy, IM_move, IM_delete, IM_date, IM_permission;
    APTR    IM_comment,Space2;

    if (!(ObjectApp = AllocVec(sizeof(struct ObjApp),MEMF_CLEAR)))
        return(NULL);

    ObjectApp->STR_TX_Infos = NULL;

    ObjectApp->CY_TypeContent[0] = GetMBString(MSG_CY_Type0);
    ObjectApp->CY_TypeContent[1] = GetMBString(MSG_CY_Type1);
    ObjectApp->CY_TypeContent[2] = GetMBString(MSG_CY_Type2);
    ObjectApp->CY_TypeContent[3] = NULL;

    ObjectApp->TX_Infos = TextObject,
        MUIA_Background, MUII_ButtonBack,
        MUIA_Frame, MUIV_Frame_Button,
        MUIA_Text_Contents, ObjectApp->STR_TX_Infos,
        MUIA_Weight, 100,
    End;

    ObjectApp->CY_Type = CycleObject,
        MUIA_HelpNode, "CY_Type",
        MUIA_Weight, 10,
        MUIA_Cycle_Entries, ObjectApp->CY_TypeContent,
    End;

    GR_up = GroupObject,
        MUIA_HelpNode, "GR_up",
        MUIA_Group_Horiz, TRUE,
        MUIA_Group_HorizSpacing, 0,
        MUIA_Group_VertSpacing, 0,
        Child, ObjectApp->TX_Infos,
        Child, ObjectApp->CY_Type,
    End;

    IM_device = ImageObject,
        MUIA_Image_Spec, "5:listers:images/Devices",
        MUIA_Frame, MUIV_Frame_ImageButton,
        MUIA_InputMode,MUIV_InputMode_RelVerify,
        MUIA_Image_FreeVert, TRUE,
        MUIA_Image_FreeHoriz, TRUE,
        MUIA_FixHeight, 22,
        MUIA_FixWidth, 25,
    End;

    IM_back = ImageObject,
        MUIA_Image_Spec, "5:listers:images/Back",
        MUIA_Frame, MUIV_Frame_ImageButton,
        MUIA_InputMode,MUIV_InputMode_RelVerify,
        MUIA_ControlChar,'\b',
        MUIA_Image_FreeVert, TRUE,
        MUIA_Image_FreeHoriz, TRUE,
        MUIA_FixHeight, 22,
        MUIA_FixWidth, 25,
    End;

    IM_select = ImageObject,
        MUIA_Image_Spec, "5:toto",
        MUIA_Frame, MUIV_Frame_ImageButton,
        MUIA_InputMode,MUIV_InputMode_RelVerify,
        MUIA_ControlChar,'a',
        MUIA_Image_FreeVert, TRUE,
        MUIA_Image_FreeHoriz, TRUE,
        //MUIA_FixHeight, 25,
        //MUIA_FixWidth, 25,
    End;

    IM_selectPattern = ImageObject,
        MUIA_Image_Spec, "5:toto",
        MUIA_Frame, MUIV_Frame_ImageButton,
        MUIA_Image_FreeVert, TRUE,
        MUIA_Image_FreeHoriz, TRUE,
        //MUIA_FixHeight, 25,
        //MUIA_FixWidth, 25,
    End;

    IM_createdir = ImageObject,
        MUIA_Image_Spec, "5:toto",
        MUIA_Frame, MUIV_Frame_ImageButton,
        MUIA_Image_FreeVert, TRUE,
        MUIA_Image_FreeHoriz, TRUE,
        //MUIA_FixHeight, 25,
        //MUIA_FixWidth, 25,
    End;

    IM_copy = ImageObject,
        MUIA_Image_Spec, "5:toto",
        MUIA_Frame, MUIV_Frame_ImageButton,
        MUIA_Image_FreeVert, TRUE,
        MUIA_Image_FreeHoriz, TRUE,
        //MUIA_FixHeight, 25,
        //MUIA_FixWidth, 25,
    End;

    IM_move = ImageObject,
        MUIA_Image_Spec, "5:toto",
        MUIA_Frame, MUIV_Frame_ImageButton,
        MUIA_Image_FreeVert, TRUE,
        MUIA_Image_FreeHoriz, TRUE,
        //MUIA_FixHeight, 25,
        //MUIA_FixWidth, 25,
    End;

    IM_delete = ImageObject,
        MUIA_Image_Spec, "5:toto",
        MUIA_Frame, MUIV_Frame_ImageButton,
        MUIA_Image_FreeVert, TRUE,
        MUIA_Image_FreeHoriz, TRUE,
        //MUIA_FixHeight, 25,
        //MUIA_FixWidth, 25,
    End;

    IM_date = ImageObject,
        MUIA_Image_Spec, "5:toto",
        MUIA_Frame, MUIV_Frame_ImageButton,
        MUIA_Image_FreeVert, TRUE,
        MUIA_Image_FreeHoriz, TRUE,
        //MUIA_FixHeight, 25,
        //MUIA_FixWidth, 25,
    End;

    IM_permission = ImageObject,
        MUIA_Image_Spec, "5:toto",
        MUIA_Frame, MUIV_Frame_ImageButton,
        MUIA_Image_FreeVert, TRUE,
        MUIA_Image_FreeHoriz, TRUE,
        //MUIA_FixHeight, 25,
        //MUIA_FixWidth, 25,
    End;

    IM_comment = ImageObject,
        MUIA_Image_Spec, "5:toto",
        MUIA_Frame, MUIV_Frame_ImageButton,
        MUIA_Image_FreeVert, TRUE,
        MUIA_Image_FreeHoriz, TRUE,
        //MUIA_FixHeight, 25,
        //MUIA_FixWidth, 25,
    End;

    Space2 = HVSpace;

    GR_buttons = GroupObject,
        MUIA_HelpNode, "GR_buttons",
        MUIA_Group_Horiz, TRUE,
        MUIA_Group_HorizSpacing, 0,
        MUIA_Group_VertSpacing, 0,
        //MUIA_Weight,20,
        Child, IM_device,
        Child, IM_back,
        Child, IM_select,
        Child, IM_selectPattern,
        Child, IM_createdir,
        Child, IM_copy,
        Child, IM_move,
        Child, IM_delete,
        Child, IM_date,
        Child, IM_permission,
        Child, IM_comment,
        Child, Space2,
    End;

    /*ObjectApp->LV_lister = DirlistObject,
        MUIA_Background, MUII_ListBack,
        MUIA_Frame, MUIV_Frame_InputList,
        MUIA_Dirlist_Directory, "work:",
        MUIA_Dirlist_MultiSelDirs, TRUE,
    End;

    ObjectApp->LV_lister = ListviewObject,
        MUIA_HelpNode, "LV_lister",
        MUIA_Listview_MultiSelect, MUIV_Listview_MultiSelect_Default,
        MUIA_Listview_List, ObjectApp->LV_lister,
    End;*/

    ObjectApp->LV_lister = Start_Lister;

    ObjectApp->GR_Lister = GroupObject,
        MUIA_HelpNode, "GR_Lister",
        MUIA_Group_Horiz, TRUE,
        MUIA_Group_HorizSpacing, 0,
        MUIA_Group_VertSpacing, 0,
        Child, ObjectApp->LV_lister,
    End;

    ObjectApp->STR_Path = StringObject,
        MUIA_Frame, MUIV_Frame_String,
        MUIA_HelpNode, "STR_Path",
        MUIA_String_MaxLen, 256,
    End;

    GROUP_ROOT_0 = GroupObject,
        MUIA_Group_HorizSpacing, 0,
        MUIA_Group_VertSpacing, 0,
        Child, GR_up,
        Child, GR_buttons,
        Child, ObjectApp->GR_Lister,
        Child, ObjectApp->STR_Path,
    End;

    ObjectApp->WI_lister = WindowObject,
        MUIA_Window_Title, GetMBString(MSG_WI_lister),
        MUIA_Window_ID, MAKE_ID('0', 'W', 'I', 'N'),
        WindowContents, GROUP_ROOT_0,
    End;

    MNlabel0MUIPrefs = MenuitemObject,
        MUIA_Menuitem_Title, GetMBString(MSG_MNlabel0MUIPrefs),
    End;

    MNlabel0AboutMUi = MenuitemObject,
        MUIA_Menuitem_Title, GetMBString(MSG_MNlabel0AboutMUi),
    End;

    MNlabel0About = MenuitemObject,
        MUIA_Menuitem_Title, GetMBString(MSG_MNlabel0About),
    End;

    MNlabel0Project = MenuitemObject,
        MUIA_Menuitem_Title, GetMBString(MSG_MNlabel0Project),
        MUIA_Family_Child, MNlabel0MUIPrefs,
        MUIA_Family_Child, MNlabel0AboutMUi,
        MUIA_Family_Child, MNlabel0About,
    End;

    ObjectApp->MN_main = MenustripObject,
        MUIA_Family_Child, MNlabel0Project,
    End;

    ObjectApp->App = ApplicationObject,
        MUIA_Application_Author, "Julien Tiphaine",
        MUIA_Application_Menustrip, ObjectApp->MN_main,
        MUIA_Application_Base, "LISTERS",
        MUIA_Application_Title, "Listers",
        //MUIA_Application_Version, "$VER: Listers 1.0 (27.05.01)",
        MUIA_Application_UseCommodities, FALSE,
        MUIA_Application_Copyright, GetMBString(MSG_AppCopyright),
        MUIA_Application_Description, GetMBString(MSG_AppDescription),
        SubWindow, ObjectApp->WI_lister,
    End;


    if (!ObjectApp->App)
    {
        FreeVec(ObjectApp);
        return(NULL);
    }

    DoMethod(MNlabel0MUIPrefs,
        MUIM_Notify, MUIA_Menuitem_Trigger, MUIV_EveryTime,
        ObjectApp->App,
        2,
        MUIM_Application_ReturnID, ID_MUIPREFS
        );

    DoMethod(MNlabel0AboutMUi,
        MUIM_Notify, MUIA_Menuitem_Trigger, MUIV_EveryTime,
        ObjectApp->App,
        2,
        MUIM_Application_ReturnID, ID_ABOUTMUI
        );

    DoMethod(MNlabel0About,
        MUIM_Notify, MUIA_Menuitem_Trigger, MUIV_EveryTime,
        ObjectApp->App,
        2,
        MUIM_Application_ReturnID, ID_ABOUT
        );

    DoMethod(ObjectApp->WI_lister,
        MUIM_Notify, MUIA_Window_CloseRequest, TRUE,
        ObjectApp->App,
        2,
        MUIM_Application_ReturnID, MUIV_Application_ReturnID_Quit
        );

    DoMethod(ObjectApp->CY_Type,
        MUIM_Notify, MUIA_Cycle_Active, MUIV_EveryTime,
        ObjectApp->App,
        2,
        MUIM_Application_ReturnID, ID_STATUS_CHANGED
        );

    DoMethod(IM_device,
        MUIM_Notify, MUIA_Pressed, FALSE,
        ObjectApp->App,
        2,
        MUIM_Application_ReturnID, ID_DEVICE_LIST
        );

    DoMethod(IM_back,
        MUIM_Notify, MUIA_Pressed, FALSE,
        ObjectApp->App,
        2,
        MUIM_Application_ReturnID, ID_BACK
        );

    DoMethod(ObjectApp->LV_lister,
        MUIM_Notify, MUIA_Listview_DoubleClick, TRUE,
        ObjectApp->App,
        2,
        MUIM_Application_ReturnID, ID_DBLCLICK_DEVICE
        );

    DoMethod(ObjectApp->STR_Path,
        MUIM_Notify, MUIA_String_Acknowledge, MUIV_EveryTime,
        ObjectApp->App,
        2,
        MUIM_Application_ReturnID, ID_USER_CHANGED_PATH
        );

    DoMethod(ObjectApp->WI_lister,
        MUIM_Window_SetCycleChain, ObjectApp->CY_Type,
        ObjectApp->LV_lister,
        ObjectApp->STR_Path,
        0
        );

    set(ObjectApp->WI_lister,
        MUIA_Window_Open, TRUE
        );

    return(ObjectApp);
}

void DisposeApp(struct ObjApp * ObjectApp,APTR list)
{
    if(ObjectApp->App)  MUI_DisposeObject(ObjectApp->App);
    if(list          )  MUI_DisposeObject(list);

    FreeVec(ObjectApp);
    //ExitClasses();
}
