#include "ListersHook.h"

PREFS Prefs;

/* build a fine string for access bit display */
void MakeAccessString(LONG AccessMask,char *string)
{
    // !!! STRING MUST BE 8 BYTES LONG !!! //
    strcpy(string,"-------\0");
    if(  AccessMask & FIBF_SCRIPT )  string[0]='s';
    if(  AccessMask & FIBF_PURE   )  string[1]='p';
    if(  AccessMask & FIBF_ARCHIVE)  string[2]='a';
    if(!(AccessMask & FIBF_READ   )) string[3]='r';
    if(!(AccessMask & FIBF_WRITE  )) string[4]='w';
    if(!(AccessMask & FIBF_EXECUTE)) string[5]='e';
    if(!(AccessMask & FIBF_DELETE )) string[6]='d';
}

/* display Hook for DirList */
//LONG DirList_DispHookFunc(/*register char **Array __asm("a2"),register struct FileInfoBlock *fib __asm("a1")*/)
M_HOOK(DirList_Disp, char **Array, struct FileInfoBlock *fib)
{
    //char **Array = (char **) REG_A2;
    //struct FileInfoBlock *fib = (struct FileInfoBlock *) REG_A1;

    static char Size[15];
    static char string[8];
    static char String2[15];
    static char Name[108];
    static char Date[15];
    static char Time[15];

    if (fib)
    {   /* make Access string */
        MakeAccessString(fib->fib_Protection,string);

        /* make date and hour string */
        MyDateTime.dat_Stamp = fib->fib_Date;
        DateToStr(&MyDateTime);

        /* make colored string ot not */
        if(fib->fib_DirEntryType<0) // it's a file
        {   sprintf(Size,"%ld",fib->fib_Size);
            sprintf(Name,"%s%s",Prefs.Display.ListFileIcon,fib->fib_FileName);
            strcpy(String2,string);
            strcpy(Date,MyDateTime.dat_StrDate);
            strcpy(Time,MyDateTime.dat_StrTime);
        }
        else
        {   sprintf(Size,"\33%i(dir)",Prefs.Display.ListDirColorPen);
            sprintf(Name,"%s\33%i%s",Prefs.Display.ListDirIcon,Prefs.Display.ListDirColorPen,fib->fib_FileName);
            sprintf(String2,"\33%i%s",Prefs.Display.ListDirColorPen,string);
            sprintf(Date,"\33%i%s",Prefs.Display.ListDirColorPen,MyDateTime.dat_StrDate);
            sprintf(Time,"\33%i%s",Prefs.Display.ListDirColorPen,MyDateTime.dat_StrTime);
        }

        *Array++ = Name;
        *Array++ = Size;
        *Array++ = Date;
        *Array++ = Time;
        *Array++ = String2;
    }
    else // it's the first call, so we write header
    {
        sprintf(Name,"%s\33%iName",Prefs.Display.ListDirFontStyle,Prefs.Display.ListDirColorPen);
        *Array++ = Name;
        sprintf(Size,"%s\33%iSize",Prefs.Display.ListDirFontStyle,Prefs.Display.ListDirColorPen);
        *Array++ = Size;
        sprintf(Date,"%s\33%iDate",Prefs.Display.ListDirFontStyle,Prefs.Display.ListDirColorPen);
        *Array++ = Date;
        sprintf(Time,"%s\33%iHour",Prefs.Display.ListDirFontStyle,Prefs.Display.ListDirColorPen);
        *Array++ = Time;
        sprintf(String2,"%s\33%iAccess",Prefs.Display.ListDirFontStyle,Prefs.Display.ListDirColorPen);
        *Array++ = String2;
    }

    return (0);
}

/* construction hook for DirList */
//APTR DirList_ConstructHookFunc(/*register APTR pool __asm("a2"),register struct FileInfoBlock *fib __asm("a1")*/)
M_HOOK(DirList_Construct,APTR pool, struct FileInfoBlock *fib)
{
    /*APTR pool = (APTR) REG_A2;
    struct FileInfoBlock *fib = (struct FileInfoBlock *) REG_A1;
    */

    struct FileInfoBlock *result=NULL;
    if (result = AllocPooled(pool,sizeof(struct FileInfoBlock)))
        memcpy(result, fib, sizeof(struct FileInfoBlock));
    return ((ULONG)result);
}

/* destruction hook for dirList */
//void DirList_DestructHookFunc(/*register APTR pool __asm("a2"),register struct FileInfoBlock *fib __asm("a1")*/)
M_HOOK(DirList_Destruct, APTR pool, struct FileInfoBlock *fib)
{
    /*APTR pool = (APTR) REG_A2;
    struct FileInfoBlock *fib = (struct FileInfoBlock *) REG_A1;
    */
    FreePooled(pool,fib,sizeof(struct FileInfoBlock));
}

/* comparison hook for DirList */
//LONG DirList_CompareHookFunc(/*register struct FileInfoBlock *fib1 __asm("a1"), register struct FileInfoBlock *fib2 __asm("a2")*/)
M_HOOK(DirList_Compare,struct FileInfoBlock *fib1, struct FileInfoBlock *fib2)
{
    /*struct FileInfoBlock *fib1 = (struct FileInfoBlock *) REG_A1;
    struct FileInfoBlock *fib2 = (struct FileInfoBlock *) REG_A2;
    */

    if (fib1->fib_DirEntryType > fib2->fib_DirEntryType) return (Prefs.Display.DirPriority);
    else if (fib1->fib_DirEntryType < fib2->fib_DirEntryType) return (Prefs.Display.FilePriority);
                                                                   
    if(Prefs.Display.SortAsc==TRUE)
        return ((LONG) stricmp(fib1->fib_FileName,fib2->fib_FileName));
    else return ((LONG) -(stricmp(fib1->fib_FileName,fib2->fib_FileName)));
}
