/* Libraries */
#include <libraries/mui.h>
#include <libraries/gadtools.h> /* for BARLABEL in MenuItem */

/* Prototypes */
#include <proto/muimaster.h>
#include <proto/exec.h>
#include <proto/dos.h>
#include <clib/alib_protos.h>

#include <clib/debug_protos.h> //SS-TBD to be removed

/* Mui Mcc */
#include <mui/NList_mcc.h>
#include <mui/NListView_mcc.h>

/* others */
#include "DirTools.h"
#include "ListersGUI.h"
#include "file_handling.h"
#include "ListersHook.h"
#include "MyList.h"
#include "main.h"

extern struct MUI_CustomClass *MyList;
#define MyListObject  NewObject(MyList->mcc_Class,NULL
extern struct Hook DirList_Disp_hook;
extern struct Hook DirList_Construct_hook;
extern struct Hook DirList_Destruct_hook;
extern struct Hook DirList_Compare_hook;

LONG MainLister(void)  //SS-TBD : blinder les cas d'erreurs, et tester a fond dans le code
{
    // lister for device and files //
    APTR Device_Lister=NULL;
    APTR Normal_Lister=NULL;

    struct ObjApp * App = NULL; // main mui Object

    struct Task *ThisTask;
    struct TaskData *td;
    struct MyList *ThisNode;
    struct MUI_NList_GetSelectInfo SelectedInfo;
    BOOL LAST_WAS_DEVICE_LISTER=TRUE,running = TRUE;
    struct FileInfoBlock *Selected=NULL;
    STRPTR Current=NULL,device=NULL,StrBuffer=NULL;
    ULONG signal;
    int i=0,len=0;

kprintf("MainLister : Entry\n");

    /* initialisations and allocs */
    //memset(Normal_Lister.Path,0,MAX_PATH_TOTAL);
//SS-TBD	memset(device,0,32);

    
	if(!(StrBuffer = malloc(256))) { printf("Out of memory !"); return -1; }

    /********* Dynamic Lister definition **********/
    // the volume lister //
    Device_Lister = VolumelistObject,
        MUIA_Background, MUII_ListBack,
        MUIA_Frame, MUIV_Frame_InputList,
        MUIA_List_Title, TRUE,
    End;

    Device_Lister = ListviewObject,
        MUIA_HelpNode, "LV_lister",
        MUIA_Listview_List, Device_Lister,
    End;


    // the Normal lister //
    Normal_Lister = NewObject(MyList->mcc_Class,NULL,
        //Normal_Lister = NListObject,
        MUIA_Background, MUII_ListBack,
        MUIA_Frame, MUIV_Frame_InputList,
        MUIA_Dirlist_MultiSelDirs, TRUE,
        MUIA_List_ShowDropMarks,TRUE,
        MUIA_List_DragSortable,TRUE,
        MUIA_List_Title, TRUE,
        MUIA_List_Format, ",,,,",
        MUIA_List_DisplayHook, &DirList_Disp_hook,//&DirList_DisplayHook,
        MUIA_List_ConstructHook, &DirList_Construct_hook,
        MUIA_List_DestructHook, &DirList_Destruct_hook,
        MUIA_List_CompareHook, &DirList_Compare_hook,
    End;

    Normal_Lister = NListviewObject,
        MUIA_HelpNode, "LV_lister",
        MUIA_Dropable, TRUE,
        MUIA_Listview_MultiSelect, MUIV_Listview_MultiSelect_Default,
        MUIA_Listview_DragType,MUIV_Listview_DragType_Immediate,
        MUIA_Listview_List, Normal_Lister,
    End;


    if(Normal_Lister==NULL) printf("[MAIN_LISTER] NORMAL LISTER NULL !!!");

    /**********************************************/


    //Create Object : generated by GenCodeC
    if (!(App = CreateApp(Device_Lister))) printf("Can't Create App\n\n");


    DoMethod(Normal_Lister/*App->LV_lister*/,MUIM_Notify,MUIA_Listview_DoubleClick,TRUE,App->App,2,MUIM_Application_ReturnID, ID_DBLCLICK);
    DoMethod(Normal_Lister/*App->LV_lister*/,MUIM_Notify,MUIA_Listview_SelectChange,TRUE,App->App,2,MUIM_Application_ReturnID, ID_MOUSEDOWN);
    DoMethod(Normal_Lister/*App->LV_lister*/,MUIM_Notify,MUIA_List_DropMark, MUIV_EveryTime,App->App,2,MUIM_Application_ReturnID, ID_DROP_ITEM);

    /* record Mui App pointer to global Env structure */
    ThisTask = FindTask(NULL);
    td = (struct TaskData *) (ThisTask->tc_UserData);
kprintf("MainLister : pass7.1 (td=0x%lx)\n", td);
	ThisNode = GetNodeByID((ULONG)td->Unique_ID,((struct Environement *)(td->Env))->Lister_list);   //SS-TBD : blinder le code ici...
kprintf("MainLister : pass7.2 (ThisNode=0x%lx)\n", ThisNode);
    ThisNode->Lister_App = App;

kprintf("MainLister : pass8\n");
    while(running)
    {
        switch (DoMethod(App->App,MUIM_Application_NewInput,&signal))
        {
            case MUIV_Application_ReturnID_Quit:
                running = FALSE;
                printf("[MAIN_LISTER] Exiting lister...\n");
                break;

            case ID_MOUSEDOWN:
            //    DoMethod(App->LV_lister,MUIM_NList_GetSelectInfo,&SelectedInfo);
            //    if(SelectedInfo.vnum>0)
                   ((struct Environement *)(td->Env))->Dragged_ID = (ULONG)td->Unique_ID;

                break;
            // end of case ID_MOUSEDOWN

            case ID_DBLCLICK:

                ((struct Environement *)(td->Env))->Dragged_ID = NULL;
				if(!(Selected = malloc(sizeof(struct FileInfoBlock)))) { printf("Out of memory !"); return -2; }
                DoMethod(App->LV_lister,MUIM_NList_GetEntry,MUIV_List_GetEntry_Active,&Selected);
                if(Selected)
                {   if(Selected->fib_DirEntryType>0)    // it's a directory
                    {   if(!SetNewPath(Selected->fib_FileName,Normal_Lister,App->STR_Path))
                        {   printf("\nBad Path !");
                        }
                    }
                    else    // it's a file
                    {   memset(StrBuffer,0,256);
                        get(Normal_Lister,MUIA_MyList_Path,&StrBuffer);
                        DoMethod(App->LV_lister,MUIM_List_Select,MUIV_List_Select_Active,MUIV_NList_Select_Off,NULL);
                        handle_file(StrBuffer,Selected->fib_FileName,0);
                    }
                }
                //if(Selected) {printf("[MAIN_LISTER] Free Selected\n"); free(Selected); }
                //Selected=NULL;
                break;
            // end of case ID_DBLCLICK

            case ID_DBLCLICK_DEVICE:
                if(device = malloc(32))
                {   DoMethod(App->LV_lister,MUIM_List_GetEntry,MUIV_List_GetEntry_Active,&device);
                    if(device)
					{
                        printf("[MAIN_LISTER] Selected %s\n",device);
                        set(Normal_Lister,MUIA_MyList_Path,device);
                        set(App->STR_Path,MUIA_String_Contents,device);

                        if(DoMethod(App->GR_Lister,MUIM_Group_InitChange))
                        {   DoMethod(App->GR_Lister,OM_REMMEMBER,App->LV_lister);
                            //DoMethod(App->LV_lister,MUIM_KillNotify,MUIA_Listview_DoubleClick);
                            DoMethod(App->GR_Lister,OM_ADDMEMBER,App->LV_lister=Normal_Lister);
                            DoMethod(App->GR_Lister,MUIM_Group_ExitChange);
                            
                            LAST_WAS_DEVICE_LISTER=FALSE;
                        }
                    }
                    //if(device) {printf("[MAIN_LISTER] Free device\n"); free(device); }
                    //device=NULL;
                }
                break;
            // end of case ID_DBLCLICK_DEVICE

            case ID_INFOS:
            break;
            // end of case ID_INFOS

            case ID_MODE:
            break;
            // end of case ID_MODE

            case ID_CLOSE:
            break;
            // end of case ID_CLOSE

            case ID_MUIPREFS:
            break;
            // end of case ID_MUIPREFS

            case ID_ABOUTMUI:
            break;
            // end of case ID_ABOUTMUI

            case ID_ABOUT: printf("\n***** ABOUT ! *****");
            break;
            // end of case ID_ABOUT

            case ID_STATUS_CHANGED:
            break;
            // end of case ID_STATUS_CHANGED

            case ID_BACK:
                GoBack(Normal_Lister,App->STR_Path);
                break;
            //end of case ID_BACK

            case ID_DEVICE_LIST:
                printf("[MAIN_LISTER] Device list button clicked\n");
                if(!LAST_WAS_DEVICE_LISTER)
                {  
                   printf("[MAIN_LISTER] Going to change lister type to device...\n");
                   if(DoMethod(App->GR_Lister,MUIM_Group_InitChange))
                   {    printf("[MAIN_LISTER] MUI Group change Initied\n");
                        
                        printf("[MAIN_LISTER] Remove Normal Lister...\n");
                        DoMethod(App->GR_Lister,OM_REMMEMBER,App->LV_lister);
                        printf("[MAIN_LISTER] Add Device lister member...\n");
                        DoMethod(App->GR_Lister,OM_ADDMEMBER,App->LV_lister=Device_Lister);
                        DoMethod(App->GR_Lister,MUIM_Group_ExitChange);

                        //printf("[MAIN_LISTER] Kill Notifications...\n");
                        //DoMethod(App->LV_lister,MUIM_KillNotify,MUIA_Listview_DoubleClick);
                        //DoMethod(App->LV_lister,MUIM_KillNotify,MUIA_List_DropMark);
                        //DoMethod(App->LV_lister,MUIM_KillNotify,MUIA_Listview_SelectChange);

                        //DoMethod(App->LV_lister,MUIM_Notify,MUIA_Listview_DoubleClick,TRUE,App->App,2,MUIM_Application_ReturnID, ID_DBLCLICK_DEVICE);
                        LAST_WAS_DEVICE_LISTER=TRUE;
                        printf("[MAIN_LISTER] Lister swap finished\n");
                   }
                }
                break;
            // end of case ID_DEVICE_LIST

            case ID_USER_CHANGED_PATH:
			{
				char dummy;
                int len;
kprintf("MainLister : pass9\n");
                memset(StrBuffer,0,256);
                get(App->STR_Path,MUIA_String_Contents,&StrBuffer);
                len = strlen(StrBuffer);
                dummy = StrBuffer[len-1];
                if(dummy!=':' && dummy!='/')
                {   StrBuffer[len]='/' ;
                    StrBuffer[len+1]='\0';
                }
//				  set(Normal_Lister,MUIA_MyList_Path,StrBuffer);
kprintf("MainLister : pass10\n");
				LAST_WAS_DEVICE_LISTER=FALSE;
                break;
            }
            // end of case ID_USER_CHANGED_PATH

            // End computing of IDCMP

            case ID_DROP_ITEM:
            break;
            // end of case ID_STATUS_CHANGED

            default:
                break;
        }
        if (running && signal) Wait(signal);
    }

kprintf("MainLister : pass11\n");
    printf("[MAIN_LISTER] Going to free ressources:\n");
	if(LAST_WAS_DEVICE_LISTER)
    {   printf("[MAIN_LISTER] Close mui app + Normal_Lister\n");
        DisposeApp(App,Normal_Lister);

    }
    else
    {    printf("[MAIN_LISTER] Close mui app + Device_Lister\n");
         DisposeApp(App,Device_Lister);
    }
    
    //if(Selected)  { printf("[MAIN_LISTER] Free Selected\n");  free(Selected);  }
    if(StrBuffer) { printf("[MAIN_LISTER] Free StrBuffer\n"); free(StrBuffer); }

    printf("[MAIN_LISTER] Finished\n");
kprintf("MainLister : Exit\n");

	return 0;
}
