/* Prototypes */
#ifdef __GNUC__
#include <proto/locale.h>
#include <proto/dos.h>
#else
#include <proto/locale.h>
#include <clib/dos_protos.h>

extern struct Library *LocaleBase;

#endif /* __GNUC__ */



static LONG ListersStrings_Version = 0;
static const STRPTR ListersStrings_BuiltInLanguage = (STRPTR) "english";

struct FC_Type
{   LONG   ID;
    char *Str;
};

/* Definitions */
const struct FC_Type _MSG_AppDescription = { 0, "Dopus like listers for workbench" };
const struct FC_Type _MSG_AppCopyright = { 1, "Julien Tiphaine" };
const struct FC_Type _MSG_MNlabel0Project = { 2, "Project" };
const struct FC_Type _MSG_MNlabel0MUIPrefs = { 3, "MUI Prefs" };
const struct FC_Type _MSG_MNlabel0AboutMUi = { 4, "About Mui" };
const struct FC_Type _MSG_MNlabel0About = { 5, "About" };
const struct FC_Type _MSG_WI_lister = { 6, "current dir" };
const struct FC_Type _MSG_TX_Infos = { 7, "" };
const struct FC_Type _MSG_CY_Type0 = { 8, "Nothing" };
const struct FC_Type _MSG_CY_Type1 = { 9, "Source" };
const struct FC_Type _MSG_CY_Type2 = { 10, "Dest" };

extern void CloseAppCatalog(void);

static struct Catalog *ListersStrings_Catalog = NULL;

void OpenAppCatalog(struct Locale *loc, STRPTR language)
{
    LONG tag, tagarg;

    CloseAppCatalog(); /* Not needed if the programmer pairs OpenAppCatalog
            and CloseAppCatalog right, but does no harm.  */

    if (ListersStrings_Catalog == NULL)
    {
        if (language == NULL)
            tag = TAG_IGNORE;
        else
        {
            tag = OC_Language;
            tagarg = (LONG) language;
        }
        ListersStrings_Catalog = OpenCatalog(loc, (STRPTR) "ListersStrings.catalog",
            OC_BuiltInLanguage,(LONG)ListersStrings_BuiltInLanguage,
            tag, tagarg,
            OC_Version, ListersStrings_Version,
            TAG_DONE);
    }
}

void CloseAppCatalog(void)
{
    CloseCatalog(ListersStrings_Catalog);
    ListersStrings_Catalog = NULL;
}

char * GetListersString(APTR fcstr)
{
    char *defaultstr;
    LONG strnum;

    strnum = ((struct FC_Type *) fcstr)->ID;
    defaultstr = ((struct FC_Type *) fcstr)->Str;

    return(ListersStrings_Catalog ? (char *)GetCatalogStr(ListersStrings_Catalog, strnum, defaultstr) :
            defaultstr);
}
