#include "Prefs.h"

PREFS Prefs;

static void LoadDefaultPrefs(void);


/***** function that Load prefs */
void  LoadPrefs(void)
{
	FILE *file;

	if((file=fopen(PREFS_FILE,"r")) != NULL)
    {   fread(&Prefs,1,sizeof(Prefs),file);
        fclose(file);
    }
    else LoadDefaultPrefs();
}

BOOL SavePrefs(void)
{
	FILE *file;

	if((file=fopen(PREFS_FILE,"w")) != NULL)
	{
        fwrite(&Prefs,1,sizeof(Prefs),file);
		return TRUE;
    }
    else return FALSE;
}

/***** function that Load default prefs *****/
static void LoadDefaultPrefs(void)
{
    /****** display ******/
    Prefs.Display.HeadFontColorPen = 8;
    Prefs.Display.ListDirColorPen  = 8;
    Prefs.Display.ListFileColorPen = 1;
    Prefs.Display.DirPriority      = 1;
    Prefs.Display.FilePriority     =-1;
    Prefs.Display.SortAsc          =TRUE;

    strcpy (Prefs.Display.HeadFontStyle,"\33b");
    sprintf(Prefs.Display.ListDirIcon  ,"\33I[6:%i]",MUII_PopDrawer);
    sprintf(Prefs.Display.ListFileIcon ,"\33I[6:%i]",MUII_PopFile);

    strcpy (Prefs.Display.ListDirFontStyle,"\33n");
    strcpy (Prefs.Display.ListFileFontStyle,"\33n");

    /****** icon bar ******/
    //sprintf(Prefs.IconBar.Devices,"6:%i",MUII_RECORD);
    //sprintf(Prefs.IconBar.Parent,"6:%i",MUII_AROWUP);

    /******* others *******/
    Prefs.DefaultStack = 16384;
    strcpy(Prefs.DefaultText,"sys:utilities/multiview");
    strcpy(Prefs.DefaultDT  ,"sys:utilities/multiview");
};


