#ifndef PREFS_H
#define PREFS_H

/* amiga */
#include <libraries/mui.h>
#include <proto/dos.h>

/* ansi */
#include <string.h>
#include <stdio.h>

/***** prefs constants *****/
#define PREFS_FILE "listers:Listers.cfg"

/***************************/

/***** Prefs structures *****/
struct PrefsDisplay
{   /* header */
    int HeadFontColorPen;
    char HeadFontStyle[10];

    /* listed directories */
    char ListDirIcon[50];
    int  ListDirColorPen;
    char ListDirFontStyle[10];

    /* listed files */
    char ListFileIcon[50];
    int  ListFileColorPen;
    char ListFileFontStyle[10];

    /* sorting prefs */
    int DirPriority;
    int FilePriority;
    BOOL SortAsc;
};

struct PrefsIcon
{   char Devices[256];
    char Parent[256];
};

/* always contain current prefs */
typedef struct PrefsLister
{   struct PrefsDisplay Display;
    struct PrefsIcon IconBar;

    long DefaultStack;          /* Default stack used for systemTags()          */
    char DefaultText[108];      /* Default Tool used to read text files         */
    char DefaultDT[108];        /* Default Tool used to read Datatypes files    */
}PREFS;

/***** Prefs functions *****/
extern void LoadPrefs(void);
extern BOOL SavePrefs(void);

#endif
